IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[tbPasswordType]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)

CREATE TABLE [dbo].[tbPasswordType]
(
     [PasswordTypeId] INT IDENTITY(1,1) PRIMARY KEY
	,[Name] [VARCHAR] (255) NOT NULL
	,[TypeName] [VARCHAR](255) NOT NULL
)

GO


IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[tbPasswordTypeField]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)

CREATE TABLE [dbo].[tbPasswordTypeField]
(
     [PasswordTypeFieldId] INT IDENTITY(1,1) PRIMARY KEY
	,[PasswordTypeId] INT NOT NULL
	,[Name] [VARCHAR](255) NOT NULL
)

GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[FK_tbPasswordTypeField_PasswordTypeId]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[tbPasswordTypeField] DROP CONSTRAINT FK_tbPasswordTypeField_PasswordTypeId
GO

ALTER TABLE [dbo].[tbPasswordTypeField] ADD 
	CONSTRAINT [FK_tbPasswordTypeField_PasswordTypeId] FOREIGN KEY 
	(
		[PasswordTypeId]
	) REFERENCES [dbo].[tbPasswordType] (
		[PasswordTypeId]
	) 
GO


ALTER TABLE [dbo].[tbSecretType]
	ADD [PasswordTypeId] INT NULL 

GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[FK_tbSecretType_PasswordTypeId]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[tbSecretType] DROP CONSTRAINT FK_tbSecretType_PasswordTypeId
GO

ALTER TABLE [dbo].[tbSecretType] ADD 
	CONSTRAINT [FK_tbSecretType_PasswordTypeId] FOREIGN KEY 
	(
		[PasswordTypeId]
	) REFERENCES [dbo].[tbPasswordType] (
		[PasswordTypeId]
	) 
GO



ALTER TABLE [dbo].[tbSecretField]
	ADD [PasswordTypeFieldId] INT NULL 

GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[FK_tbSecretField_PasswordTypeFieldId]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[tbSecretField] DROP CONSTRAINT FK_tbSecretField_PasswordTypeFieldId
GO

ALTER TABLE [dbo].[tbSecretField] ADD 
	CONSTRAINT [FK_tbSecretField_PasswordTypeFieldId] FOREIGN KEY 
	(
		[PasswordTypeFieldId]
	) REFERENCES [dbo].[tbPasswordTypeField] (
		[PasswordTypeFieldId]
	) 
GO


ALTER TABLE [dbo].[tbSecretType]
	ADD [PasswordTypeReady] BIT NOT NULL DEFAULT (0)

GO
